%define name    executor
%define version 0.6.3
%define release csa10
%define prefix /usr/mbin

Summary:    Soul System Administration Scripts
Name:       %{name}
Version:    %{version}
Release:    %{release}
Source:	    %{name}.tar.bz2
Copyright:  GPL
Group:	    System/Servers
Distribution:	DarkLin
Vendor:		DarkSoft
Requires:	openssl, perl, perl-MD5, perl-Crypt-Cracklib
BuildRequires:	perl
Packager:	Kain <ds7fff@myrealbox.com>
BuildRoot:  /var/tmp/%{name}-%{version}-root
BuildArch:	noarch

%description
 Soul System Managment Scripts. Base scripts and Certificate Managment.

%package rb
Summary:    Soul System Administration Scripts ( RB Clients )
Group:	    System/Servers
Requires:   executor

%description rb
 Soul System Managment Scipts. Remote Boot Clients.
 
%package password
Summary:    Soul System Administration Scripts ( Passwords )
Group:	    System/Servers
Requires:   executor

%description password
 Soul System Managment Scipts. Password Managment.

%package ca
Summary:    Soul System Administration Scripts ( CA )
Group:	    System/Servers
Requires:   executor

%description ca
 Soul System Managment Scipts. CA Managment.


%package perms
Summary:    Soul System Administration Scripts ( Permissions )
Group:	    System/Servers
Requires:   executor

%description perms
 Soul System Managment Scipts. Permission Managment.

%package user
Summary:    Soul System Administration Scripts ( Users )
Group:	    System/Servers
Requires:   executor

%description user
 Soul System Managment Scipts. User and Computer Managment.


%prep
%setup -c 

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{prefix}
mkdir -p $RPM_BUILD_ROOT/etc
mkdir -p $RPM_BUILD_ROOT/etc/user.pwd
echo >  $RPM_BUILD_ROOT/etc/admin.pwd
echo "Enter apache password here" > $RPM_BUILD_ROOT/etc/apc.pwd
echo > $RPM_BUILD_ROOT/etc/admin.list
echo > $RPM_BUILD_ROOT/etc/guest.list

(
    cd $RPM_BUILD_ROOT/usr/mbin
    rm -f changeldappwd
    rm -f changecapwd
    ln -s changepwd changeldappwd
    ln -s changepwd changecapwd
)

#A=$(perl -e '$s=`perl -v`; $s =~ /v(5\.\S*)/; print $1;')
#mkdir -p $RPM_BUILD_ROOT/usr/lib/perl5/"$A"
#install -m 644 CheckAdminPassword.pm $RPM_BUILD_ROOT/usr/lib/perl5/"$A"

cp * $RPM_BUILD_ROOT/%prefix




%pre
 # Creating ca group
 if [ "$1" = 1 ]; then 
    groupadd -r executor
    perl -pi -e '
	s|(^executor:.*:.*:.+$)|$1,apache|g;
	s|(^executor:.*:.*:$)|$1apache|g;
	' /etc/group
 fi

%postun
    if [ "$1" = 0 ]; then 
	groupdel executor
#	perl -pi -e '
#	    s|(^executor:.*:.*:)apache$|$1|g;
#	    s|(^executor:.*:.*:.+),apache$|$1|g;
#	    s|(^executor:.*:.*:)apache,(.*)$|$1$2|g;
#	    s|(^executor:.*:.*:.+),apache(,.*)$|$1$2|g;
#	    ' /etc/group
    fi


%clean
rm -rf $RPM_BUILD_ROOT

%files
%attr(0640,root,executor) %prefix/CheckAdminPassword.pm
%attr(0640,root,executor) %prefix/executor_conf.pm
%attr(6710,root,executor) %prefix/checkpwd
%attr(0700,root,executor) %prefix/apc-pass

%dir /etc/user.pwd
%attr(0640,root,executor) %config(noreplace) /etc/admin.pwd
%attr(0600,root,root) %config(noreplace) /etc/apc.pwd

%attr(0644,root,executor) /etc/admin.list
%attr(0644,root,executor) /etc/guest.list

%files rb 
%attr(0640,root,executor) %prefix/rb_tools.pm

%attr(0700,root,executor) %prefix/rb_cloneperms_all.pl*
%attr(0700,root,executor) %prefix/rb_cloneperms.pl*
%attr(0700,root,executor) %prefix/rb_genBootScripts.pl*
%attr(0700,root,executor) %prefix/rb_install_host.pl*
%attr(0700,root,executor) %prefix/rb_makedif.pl*
%attr(0700,root,executor) %prefix/rb_recreate_boot.pl*
%attr(0700,root,executor) %prefix/rb_recreate_var.pl*
%attr(0700,root,executor) %prefix/rb_spawn_srv_config_all.pl*
%attr(0700,root,executor) %prefix/rb_spawn_srv_config.pl*

%files password
%prefix/changecapwd
%prefix/changeldappwd
%attr(0700,root,executor) %prefix/changepwd
%attr(0700,root,executor) %prefix/changeldaphackpwd

%files ca
#DS %attr(0700,root,executor) %prefix/restore-ssl-config*
%attr(6710,root,executor) %prefix/openssl.signcert
%attr(6710,root,executor) %prefix/openssl.revoke
%attr(6710,root,executor) %prefix/openssl.selca
%attr(6710,root,executor) %prefix/openssl.crl

%files perms
%attr(0700,root,executor) %prefix/fixperms
%attr(0700,root,executor) %prefix/fixsysperms

%files user
%attr(6710,root,executor) %prefix/au
%attr(6710,root,executor) %prefix/cup
%attr(6710,root,executor) %prefix/getup
%attr(6710,root,executor) %prefix/setquota
%attr(6710,root,executor) %prefix/updatepc

