%define build_chain 0

%define prefix  /opt/ssl
%define caname	Dummy
%define capath	%{prefix}/ca-%{caname}
%define name    ssl-certs-ca-%{caname}
%define version 0.5
%define release csa14

Summary:    CA certificate & private key for %{caname}
Name:       %{name}
Version:    %{version}
Release:    %{release}
Copyright:  GPL
Group:	    System/Servers
Distribution:	DarkLin
Vendor:		DarkSoft
Provides:	ssl-certs-ca
BuildRequires:  openssl
Requires:	rpm >= 4.0, ssl-certs
Packager:	Kain <ds7fff@myrealbox.com>
BuildRoot:  /var/tmp/%{name}-%{version}-root
BuildArch:	noarch
%if %build_chain
Source1:	chain.crt
%endif

%prep
%setup -c -T

%description
 CA(Certificate Authority) certificate & private key for %{caname}
 Password: qwerty
 
%install
    rm -rf $RPM_BUILD_ROOT
    mkdir -p $RPM_BUILD_ROOT/%{capath}/private
    mkdir -p $RPM_BUILD_ROOT/%{capath}/backup
    mkdir -p $RPM_BUILD_ROOT/%{capath}/newcerts
    
    openssl req -new -x509 -days 3650 -keyout %{caname}.key -out %{caname}.crt

    install %{caname}.key $RPM_BUILD_ROOT/%{capath}/private/server.key
    install %{caname}.crt $RPM_BUILD_ROOT/%{capath}/server.crt

    mkdir -p $RPM_BUILD_ROOT/%{capath}/private
    echo "01" > $RPM_BUILD_ROOT/%{capath}/serial

    echo -n > $RPM_BUILD_ROOT/%{capath}/index.txt

%if %build_chain
    install %SOURCE1 $RPM_BUILD_ROOT/%{capath}/
    cat %{caname}.crt >> $RPM_BUILD_ROOT/%{capath}/chain.crt
%else
    install %{caname}.crt $RPM_BUILD_ROOT/%{capath}/chain.crt
%endif
    
    mkdir -p $RPM_BUILD_ROOT/%prefix/crl/
    ln -s ../ca-%{caname}/server.crl $RPM_BUILD_ROOT/%prefix/crl/%{caname}.crl

    /usr/mbin/changecapwd $RPM_BUILD_ROOT/%{capath}/password

%post
 # Creating random data
    dd if=/dev/urandom of=$RPM_BUILD_ROOT/%{capath}/private/.rand count=1 &>/dev/null
    chmod 0640 $RPM_BUILD_ROOT/%{capath}/private/.rand
    chown root.ca $RPM_BUILD_ROOT/%{capath}/private/.rand

    if [ "$1" = 1 ]; then
	update-alternatives --install %{prefix}/ca ca %{capath} 1
	openssl ca -gencrl -keyfile %{capath}/private/server.key -cert %{capath}/server.crt -out %{capath}/server.crl
    fi	

    perl -e '
$hash_extension = "r";

sub hash_resort {
    my $i, $pos, $prefix, $fn, $link, $eflag;
    
    $prefix=@_[0];
    $link=@_[1];
    
    $pos=0;
    for ($i=0;lstat($prefix . "." . $hash_extension . $i);$i++) {
	$fn=$prefix . "." . $hash_extension . $i;
	if (-f $fn) {
	    if ($link eq readlink($fn)) { $eflag=1; }

	    if ($pos<$i) {
		rename($fn, $prefix . "." . $hash_extension . $pos);
	    }
	    $pos++;
	} else {
	    unlink($fn);
	}
    }
    
    if ($eflag) { return -1; }
    return $pos;
}

$hash=`openssl crl -noout -hash -in %capath/server.crl`;
chomp($hash);
$hash_free=hash_resort("%prefix" . "/crl/" . $hash, "../ca-%caname/server.crl");
if ($hash_free>=0) {
    system("/bin/ln","-s","../ca-%caname/server.crl", "%prefix/crl/" . $hash . "." . $hash_extension . $hash_free);
}
'

%preun
    if [ "$1" = 0 ]; then 
        rm -rf /opt/ssl/ca/private/.rand	

	update-alternatives --remove ca %{capath}
    fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%attr(0755,root,ca) %dir %{prefix}
%attr(0755,root,ca) %dir %{capath}
%attr(0750,root,ca) %dir %{capath}/private
%attr(0644,root,ca) %{capath}/server.crt
%attr(0640,root,ca) %{capath}/private/server.key
%attr(0644,root,ca) %{capath}/chain.crt
%attr(0775,root,executor) %dir %{capath}/newcerts
%attr(0640,root,executor) %{capath}/password
%attr(0664,root,ca) %config(noreplace) %{capath}/serial
%attr(0664,root,ca) %config(noreplace) %{capath}/index.txt
#/%prefix/crl/%{caname}.crl
