%define name    ssl-certs
%define version 0.5
%define release csa9
%define sslconfig /usr/lib/ssl/openssl.cnf

Summary:    CA base directory structure
Name:       %{name}
Version:    %{version}
Release:    %{release}
Copyright:  GPL
Group:	    System/Servers
Source1:	regenerate
Source2:	update_users
Distribution:	DarkLin
Vendor:		DarkSoft
Requires:	%{name}-ca, openssl, /bin/dd, perl, executor
Packager:	Kain <ds7fff@myrealbox.com>
BuildRoot:  /var/tmp/%{name}-%{version}-root
BuildArch:	noarch

%description
 CA(Certificate Authorite) base directory structure. 
 Modifies openssl configuration files
 Requires CA certificate & private key to be present 


%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/opt/ssl
#mkdir -p $RPM_BUILD_ROOT/opt/ssl/ca
mkdir -p $RPM_BUILD_ROOT/opt/ssl/certs
mkdir -p $RPM_BUILD_ROOT/opt/ssl/crl
#mkdir -p $RPM_BUILD_ROOT/opt/ssl/newcerts
mkdir -p $RPM_BUILD_ROOT/opt/ssl/server_certs
mkdir -p $RPM_BUILD_ROOT/opt/ssl/client_certs
mkdir -p $RPM_BUILD_ROOT/opt/ssl/user_certs
mkdir -p $RPM_BUILD_ROOT/opt/ssl/server_keys
mkdir -p $RPM_BUILD_ROOT/opt/ssl/client_keys
mkdir -p $RPM_BUILD_ROOT/opt/ssl/user_keys
mkdir -p $RPM_BUILD_ROOT/opt/ssl/user_pkcs7
mkdir -p $RPM_BUILD_ROOT/opt/ssl/CAs
mkdir -p $RPM_BUILD_ROOT/opt/ssl/server_courier

mkdir -p $RPM_BUILD_ROOT/opt/ssl/tmp


#mkdir -p $RPM_BUILD_ROOT/opt/ssl/ca/private
#echo "01" > $RPM_BUILD_ROOT/opt/ssl/ca/serial

#echo -n > $RPM_BUILD_ROOT/opt/ssl/index.txt

install -m 600 %SOURCE1 $RPM_BUILD_ROOT/opt/ssl/
install -m 600 %SOURCE2 $RPM_BUILD_ROOT/opt/ssl/

#ln -s ../ca/server.crl $RPM_BUILD_ROOT/opt/ssl/crl/local.crl

mkdir -p $RPM_BUILD_ROOT/usr/bin/
cat << EOF > $RPM_BUILD_ROOT/usr/bin/restore-ssl-config 
    perl -pi -e '
	s|(^dir\s*=).*$|\$1 /opt/ssl|g;
	s|(^database\s*=).*$|\$1 \\\$dir/ca/index.txt|g;
	s|(^new_certs_dir\s*=).*$|\$1 \\\$dir/ca/newcerts|g;
	s|(^certificate\s*=).*$|\$1 \\\$dir/ca/server.crt|g;
	s|(^serial\s*=).*$|\$1 \\\$dir/ca/serial|g;
	s|(^crl\s*=).*$|\$1 \\\$dir/ca/crl.pem|g;
	s|(^private_key\s*=).*$|\$1 \\\$dir/ca/private/server.key|g;
	s|(^RANDFILE\s*=).*\\\$dir.*$|\$1 \\\$dir/ca/private/.rand|g;
	' %{sslconfig}
EOF

%pre
 # Creating ca group
 if [ "$1" = 1 ]; then 
    groupadd -r ca
#    perl -pi -e '
#	s|(^ca:.*:.*:.+$)|$1,apache|g;
#	s|(^ca:.*:.*:$)|$1apache|g;
#	' /etc/group
 fi

%postun
    if [ "$1" = 0 ]; then 
	groupdel ca
#	perl -pi -e '
#	    s|(^ca:.*:.*:)apache$|$1|g;
#	    s|(^ca:.*:.*:.+),apache$|$1|g;
#	    s|(^ca:.*:.*:)apache,(.*)$|$1$2|g;
#	    s|(^ca:.*:.*:.+),apache(,.*)$|$1$2|g;
#	    ' /etc/group
    fi

%preun
    if [ "$1" = 0 ]; then 
        rm -rf /opt/ssl/ca/private/.rand	
    fi

%post
 # Creating random data
#    dd if=/dev/urandom of=$RPM_BUILD_ROOT/opt/ssl/ca/private/.rand count=1 &>/dev/null
#    chmod 0640 $RPM_BUILD_ROOT/opt/ssl/ca/private/.rand
#    chown root.ca $RPM_BUILD_ROOT/opt/ssl/ca/private/.rand

 # Changing OpenSSL configuration
    perl -pi -e '
	s|(^dir\s*=).*$|$1 /opt/ssl|g;
	s|(^database\s*=).*$|$1 \$dir/ca/index.txt|g;
	s|(^new_certs_dir\s*=).*$|$1 \$dir/ca/newcerts|g;
	s|(^certificate\s*=).*$|$1 \$dir/ca/server.crt|g;
	s|(^serial\s*=).*$|$1 \$dir/ca/serial|g;
	s|(^crl\s*=).*$|$1 \$dir/ca/crl.pem|g;
	s|(^private_key\s*=).*$|$1 \$dir/ca/private/server.key|g;
	s|(^RANDFILE\s*=).*\$dir.*$|$1 \$dir/ca/private/.rand|g;
	' %{sslconfig}



%clean
rm -rf $RPM_BUILD_ROOT

%files
%attr(0775,root,ca) %dir /opt/ssl/
#attr(0775,root,ca) %dir /opt/ssl/ca/
#attr(0750,root,ca) %dir /opt/ssl/ca/private
%attr(0755,root,ca) %dir /opt/ssl/certs
%attr(0755,root,ca) %dir /opt/ssl/crl
#%attr(0644,root,ca) /opt/ssl/crl/local.crl
#attr(0775,root,executor) %dir /opt/ssl/newcerts
%attr(0775,root,ca) %dir /opt/ssl/server_certs
%attr(0775,root,ca) %dir /opt/ssl/client_certs
%attr(0775,root,ca) %dir /opt/ssl/user_certs
%attr(0770,root,ca) %dir /opt/ssl/server_keys
%attr(0770,root,ca) %dir /opt/ssl/client_keys
%attr(0770,root,ca) %dir /opt/ssl/user_keys
%attr(0770,root,ca) %dir /opt/ssl/user_pkcs7
%attr(0775,root,ca) %dir /opt/ssl/CAs
%attr(0770,root,ca) %dir /opt/ssl/server_courier
%attr(0730,root,executor) %dir /opt/ssl/tmp
#attr(0664,root,ca) /opt/ssl/ca/serial
#attr(0664,root,ca) /opt/ssl/index.txt
%attr(0600,root,root) /opt/ssl/regenerate
%attr(0600,root,root) /opt/ssl/update_users

%attr(0755,root,root) /usr/bin/restore-ssl-config
